SET ESCAPE OFF
SET FORMAT TO fscr NOCLEAR
SET INTENSITY OFF
SET DELETED ON

DO screen

USE cdrom INDEX cdr
COUNT TO end
GOTO TOP

DECLARE cdrom[end]

cd = 1
DO WHILE cd < end       
   cdrom[cd] = title
   cd = cd + 1
   SKIP
ENDDO
cdrom[cd] = title

tPag = Ceiling(end/17)                   && Total pages
cd = 1                                   && Current CD-ROM
pag = 1                                  && Current page
row = 3                                  && Current row

DO list 

SET COLOR TO GR+/B
@ row,16 SAY cdrom[cd]

SET COLOR TO N/N
kin = " "
@ 2,0 GET kin
DO WHILE .T.
   READ                                          
   DO CASE
      CASE LastKey() = 3                         && <Page Down>
           IF cd = end
              LOOP
           ENDIF
           IF pag = tPag
              SET COLOR TO W+/N
              @ row,16 SAY cdrom[cd]
              row = row + (end - cd)
              cd = end
           ELSE
              IF (cd + 17) > end
                 row = row - ((cd + 17) - end)
                 cd = end
              ELSE   
                 cd = cd + 17
              ENDIF
              pag = pag + 1
              DO list
           ENDIF

      CASE LastKey() = 5                         && Up Arrow
           IF cd = 1
              LOOP
           ENDIF
           IF row = 3                           
              cd = cd - 1
              pag = pag - 1
              DO list
              row = 19
           ELSE
              SET COLOR TO W+/N
              @ row,16 SAY cdrom[cd]
              row = row - 1
              cd = cd - 1
           ENDIF
           
      CASE LastKey() = 13                          && <Enter>
           SEEK cdrom[cd]
           IF .NOT. online
              DO BoxB WITH 7,16,14,61,"+a"
              SET COLOR TO W+/B
              @ 8,18 SAY "The selected CD-ROM is currently Off-line,"
              @ 9,18 SAY "but will be on-line again on         ."
              @ 9,47 SAY date
              @ 10,18 SAY "To download a listing of all files on the"
              @ 11,18 SAY "CD-ROM, select < >."
              SET COLOR TO GR+/B
              @ 11,34 SAY "D"
              SET COLOR TO B/B
              @ 12,34 SAY " "
              key = InKey(40)
              SET COLOR TO N/N
              @ 7,16 CLEAR TO 14,61
           ELSE
              p = RTrim(path)
              f = RTrim(farfile)
              o = RTrim(odata)
              opt = p + f + Chr(32) + o
              a = acc + 1
              REPLACE acc WITH a
              DOTBBS TYPE 4 OPTDATA opt
              USE cdrom INDEX cdr
              DO screen
           ENDIF
           DO list

      CASE LastKey() = 18                        && <Page Up>
           IF cd = 1
              LOOP
           ENDIF
           IF pag = 1
              SET COLOR TO W+/N
              @ row,16 SAY cdrom[cd]
              row = row - (cd - 1)
              cd = 1
           ELSE
              cd = cd - 17
              pag = pag - 1
              DO list
           ENDIF
      
      CASE LastKey() = 24                        && Down Arrow
           IF cd = end
              LOOP
           ENDIF
           IF row = 19
              cd = cd + 1
              pag = pag + 1
              DO list
              row = 3                   
           ELSE
              SET COLOR TO W+/N
              @ row,16 SAY cdrom[cd]
              row = row + 1
              cd = cd + 1
           ENDIF
      
      CASE LastKey() = 27                   && <Esc>
           QUIT                                
      
      CASE LastKey() = 68 .OR. LastKey() = 100      && D or d: Download
           SEEK cdrom[cd]
           p = RTrim(path) + "/NB /NBC /NL /I:"
           f = RTrim(listfile)
           z = zip + 1
           REPLACE zip WITH z
           DOTBBS TYPE 34 OPTDATA  p + Chr(34) + f + Chr(34)
           USE cdrom INDEX cdr
           DO list
   
   ENDCASE
   SET COLOR TO GR+/B
   @ row,16 SAY cdrom[cd]
ENDDO
QUIT

**************************************************
PROCEDURE list

PRIVATE row
row = 3
n = Int((pag-1)*17) + 1         

SET COLOR TO N/N
@ 2,0 CLEAR TO 20,79

DO WHILE row <= 19                             
         SEEK cdrom[n]
         
         SET COLOR TO GR+/N                      
         @ row,1 SAY "["                           
         @ row,2 SAY n PICTURE "@Z 99"         
         @ row,4 SAY "]"                           
         IF online
            SET COLOR TO G+/N
            @ row,6 SAY "On-Line " 
         ELSE 
            SET COLOR TO R+/N
            @ row,6 SAY date
         ENDIF
         
         SET COLOR TO W+/N                        
         @ row,16 SAY title                       
         
         IF n = end
            EXIT                                  
         ENDIF
         row = row + 1                            
         n = n + 1
ENDDO
RETURN

**************************************************
PROCEDURE screen

SET COLOR TO N/N
@ 0,0 CLEAR
SET COLOR TO R/R
@ 0,0 CLEAR TO 1,79
@ 21,0 CLEAR TO 23,79
SET COLOR TO N/R
@ 0,55 SAY "CD-ROM Manager s1.0" 
@ 1,55 SAY "c.1996 LocalNet BBS" 
SET COLOR TO GR+/R
@ 0,3 SAY "CD-ROM Directory"
@ 21,3 SAY "Cursor Keys"
@ 21,49 SAY "D"
@ 23,7 SAY "<Enter>"
@ 23,45 SAY "<Esc>"                                  
SET COLOR TO W+/R
@ 1,6 SAY "On-line                   Title"  
@ 21,15 SAY "= Move highlite bar"
@ 21,51 SAY "= Download file list"
@ 22,53 SAY   "for highlited CD-ROM"
@ 23,15 SAY "= Select highlited CD-ROM"
@ 23,51 SAY "= Quit"
RETURN

**************************************************
PROCEDURE BoxB
PARAMETERS x,y,n,c,s

SET COLOR TO B/B
@ x,y CLEAR TO n,c
IF "s" $ s
  SET COLOR TO N/N
  @ n+1,y+1 CLEAR TO n+1,c
  @ x+1,c+1 CLEAR TO n+1,c+1
ENDIF
SET COLOR TO N/B
IF "+" $ s
  SET COLOR TO B+/B
ENDIF
@ x,y SAY ""
@ x,y+1 TO x,c
@ x,c SAY ""
@ x+1,y TO n,y
@ n,y SAY ""
IF "a" $ s
  SET COLOR TO W+/B
  @ n-1,Ceiling((c-y-11)/2)+y SAY "< ANY KEY >"
ENDIF                           
SET COLOR TO N/B
@ x+1,c TO n,c              
@ n,y+1 TO n,c               
@ n,c SAY ""                
RETURN

